Fresh bionic installs with DI don't mention netplan in ENI

Bug #1756742 reported by Mark Shuttleworth on 2018-03-18
12
This bug affects 2 people
Affects Status Importance Assigned to Milestone
netplan
Undecided
Unassigned
finish-install (Ubuntu)
High
Mathieu Trudel-Lapierre
netplan.io (Ubuntu)
High
Mathieu Trudel-Lapierre
nplan (Ubuntu)
Undecided
Unassigned
Artful
Undecided
Unassigned

Bug Description

[Impact]
All users of netplan on new installs of Ubuntu 18.04.

[Test case]
1) Install 18.04.
2) Open /etc/network/interfaces for editing.
3) Verify that it contains text to notify the user that Ubuntu 18.04 now uses netplan for network configuration.

[Regression Potential]
Upgraded systems and other customized installations may already contain /etc/network/interfaces with existing settings for network devices. These should not have the /etc/network/interfaces file modified in any way, and retain previous network settings and connectivity. Behavior changes in systems running ifupdown instead of netplan may indicate a potential regression caused by netplan modifying /etc/network/interfaces. Newly installed systems should include the appropriate netplan configuration for that system under /etc/netplan/*.yaml (either as configuration from the installer, in which case static IPs or DHCP may be used, or as a simple file setting the renderer to "NetworkManager" in the case of desktop installs). Newly installed systems should additionally include a comments-only /etc/network/interfaces pointing to /etc/netplan. Changes in connectivity behavior on existing installs should be investigated as possible regressions. Changes in connectivity behavior in new installs (compared to previous releases) would typically not be regressions from this SRU, but should be noted as possible limitations in netplan, and thus require bug reports.

---

I have a fresh Bionic install with DI which doesn't mention netplan in ENI:

$ more interfaces
# /etc/network/interfaces -- configuration file for ifup(8), ifdown(8)
# Generated by debian-installer.

# The loopback interface
auto lo
iface lo inet loopback

This is particularly confusing since ifupdown is not installed :)

I think this file wants to say that netplan is installed by default, ifupdown is still available if needed, and where to go for more information.

This needs further investigation: d-i is doing something wrong if it's still writing /e/n/i, as netplan would otherwise have written the correct file on install.

This smells like a bug in netcfg. What was the network configuration for this install?

Assigning to myself while I run some d-i installs here to try to reproduce.

Changed in netcfg (Ubuntu):
assignee: nobody → Mathieu Trudel-Lapierre (cyphermox)
Changed in netplan:
status: New → Incomplete
Changed in netcfg (Ubuntu):
status: New → Incomplete
importance: Undecided → High

Confirmed; finish-install includes code that only checks for the presence of /e/n/i.

Changed in netcfg (Ubuntu):
status: Incomplete → Triaged
affects: netcfg (Ubuntu) → finish-install (Ubuntu)
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package finish-install - 2.59ubuntu2

---------------
finish-install (2.59ubuntu2) bionic; urgency=medium

  * finish-install.d/50config-target-network: (LP: #1756742)
    - don't write out a generic /etc/network/interfaces if no network config
      exists.
    - if /etc/netplan/*.yaml config exist and /e/n/i doesn't, write breadcrumbs
      to point users to netplan.

 -- Mathieu Trudel-Lapierre <email address hidden> Tue, 20 Mar 2018 11:50:56 -0400

Changed in finish-install (Ubuntu):
status: Triaged → Fix Released

While I added the right "breadcrumbs" in finish-install; I've also updated the text in netplan.io postinst. I'm preparing a release for that and some other smalls bugs right now.

Changed in netplan:
status: Incomplete → Fix Committed
Changed in netplan.io (Ubuntu):
status: New → In Progress
importance: Undecided → High
assignee: nobody → Mathieu Trudel-Lapierre (cyphermox)
Steve Langasek (vorlon) wrote :

The netplan.io in question was released, but there is a bug in the postinst that compares versions with lt-nl instead of lt, which means the breadcrumbs are not created on first install.

We should get this fixed, and drop the duplicate code in finish-install.

Changed in netplan.io (Ubuntu):
status: In Progress → Triaged

Upload of netplan.io 0.35 that resolves this is in bionic unapproved queue now. Once that lands, I'll reupload finish-install.

Changed in netplan.io (Ubuntu):
status: Triaged → Fix Committed
Changed in finish-install (Ubuntu):
status: Fix Released → Triaged
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package netplan.io - 0.35

---------------
netplan.io (0.35) bionic; urgency=medium

  * debian/postinst: fix version check for when to write breadcrumbs.
    (LP: #1756742)
  * bonds/bridges: Support specifying time-based values with "ms" suffix when
    the value should be in milliseconds; while keeping support for the previous
    behavior of handling values are pure seconds when no suffix is present.
    (LP: #1745597)
  * IPv6: accept-ra should default to being unset, so that the kernel default
    can be used. (LP: #1732002)
  * DHCPv4: add a "dhcp-identifier: mac" field that can be set to fix interop
    with Windows Server-based DHCP servers which don't support RFC 4361.
    (LP: #1738998)
  * docs, examples: reformat comments in examples, add standalone example files
  * debian/docs, debian/netplan.io.install: install doc and examples in the
    right locations.
  * netplan try: allow users to preview/test and approve network configuration
    changes, and automatically revert if they are not accepted. (LP: #1764824)
  * networkd: don't wipe out /run/netplan on generate: we do want to keep any
    YAML configurations in that directory, we just need to remove generated
    wpasupplicant configs. (LP: #1764869)
  * debian/control: add bash-completion to Build-Depends to make sure we do
    install completion files in the right location.

 -- Mathieu Trudel-Lapierre <email address hidden> Tue, 17 Apr 2018 21:49:21 -0400

Changed in netplan.io (Ubuntu):
status: Fix Committed → Fix Released
description: updated
Changed in nplan (Ubuntu):
status: New → Fix Released

Hello Mark, or anyone else affected,

Accepted nplan into artful-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/nplan/0.32~17.10.4 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-artful to verification-done-artful. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-artful. In either case, without details of your testing we will not be able to proceed.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in nplan (Ubuntu Artful):
status: New → Fix Committed
tags: added: verification-needed verification-needed-artful

Verification-done on artful: nplan 0.32~17.10.4

On install of 0.32~17.10.4 on a new MAAS-installed VM and hardware, /etc/network/interfaces is created and points to netplan.

tags: added: verification-done-artful
removed: verification-needed verification-needed-artful
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package nplan - 0.32~17.10.4

---------------
nplan (0.32~17.10.4) artful; urgency=medium

  * bond/bridge: Support suffixes for time-based values so things like
    "mii-monitor-interval" can support milliseconds. (LP: #1745597)
  * debian/postinst: Write breadcrumbs on disk in /etc/network/interfaces to
    denote the migration to using netplan. (LP: #1756742)
  * DHCPv4: add a "dhcp-identifier: mac" field that can be set to fix interop
    with Windows Server-based DHCP servers which don't support RFC 4361.
    (LP: #1738998)
  * IPv6: accept-ra should default to being unset, so that the kernel default
    can be used. (LP: #1732002)
  * doc/netplan.md: Clarify the behavior for time-based values for bonds
    and bridges. (LP: #1756587)
  * critical: provide a way to set "CriticalConnection=true" on a networkd
    connection, especially for remote-fs scenarios. (LP: #1769682)
  * networkd: don't wipe out /run/netplan on generate: we do want to keep any
    YAML configurations in that directory, we just need to remove generated
    wpasupplicant configs. (LP: #1764869)

 -- Mathieu Trudel-Lapierre <email address hidden> Tue, 08 May 2018 11:04:30 -0400

Changed in nplan (Ubuntu Artful):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for nplan has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers